-- author: DD ModPassion
-- date: 04.02.2020
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: farming simulator 19
WashableAddon = {} function WashableAddon.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(Washable, specializations) end function WashableAddon.registerFunctions(vehicleType) SpecializationUtil.registerFunction(vehicleType, "setWashableAddon", WashableAddon.setWashableAddon) end function WashableAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", WashableAddon) SpecializationUtil.registerEventListener(vehicleType, "onReadStream", WashableAddon) SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", WashableAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", WashableAddon) SpecializationUtil.registerEventListener(vehicleType, "onDraw", WashableAddon) SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", WashableAddon) end function WashableAddon:onLoad(savegame) local spec = self.spec_washable spec.washableValue = false end function WashableAddon:onReadStream(streamId, connection) if connection:getIsServer() then local washableValue = streamReadBool(streamId) self:setWashableAddon(washableValue, true) end end function WashableAddon:onWriteStream(streamId, connection) if not connection:getIsServer() then local spec = self.spec_washable streamWriteBool(streamId, spec.washableValue) end end function WashableAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_washable if spec.washableNodes == nil then return end if spec.washableValue then local dirtAmount = 0 for i, nodeData in ipairs(spec.washableNodes) do if dirtAmount < self:getNodeDirtAmount(nodeData) then dirtAmount = self:getNodeDirtAmount(nodeData) end end if dirtAmount == 0 then self:setWashableAddon(false) else self:addDirtAmount(-10 * dt / self:getWashDuration()) if self.isServer then local farmId = self:getOwnerFarmId() local price = 10 * (dt / 1000) local stats = g_farmManager:getFarmById(g_currentMission.player.farmId).stats stats:updateStats("expenses", price) g_currentMission:addMoney(-price, farmId, MoneyType.VEHICLE_RUNNING_COSTS) end end end end function WashableAddon:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_washable if spec.washableValue and isActiveForInput then local dirtAmount = 0 for i, nodeData in ipairs(spec.washableNodes) do if dirtAmount < self:getNodeDirtAmount(nodeData) then dirtAmount = self:getNodeDirtAmount(nodeData) end end g_currentMission:addExtraPrintText(string.format(g_i18n:getText("fieldJob_progress")..": %0.3f -> "..self:getFullName(), dirtAmount)) end end function WashableAddon:onRegisterActionEvents(isActiveForInput, isActiveForInputIgnoreSelection) local spec = self.spec_washable if self.isClient and spec.washableNodes ~= nil then self:clearActionEventsTable(spec.actionEvents) if isActiveForInputIgnoreSelection then local _, actionEventId = self:addActionEvent(spec.actionEvents, InputAction.WASHABLE_OBJECT, self, WashableAddon.washableObject, false, true, false, true, nil) g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_NORMAL) g_inputBinding:setActionEventActive(actionEventId, true) g_inputBinding:setActionEventTextVisibility(actionEventId, true) local text = string.format(g_i18n:getText("statistic_cleanliness")..": "..self:getFullName()) g_inputBinding:setActionEventText(actionEventId, text) end end end function WashableAddon.washableObject(self, actionName, inputValue, callbackState, isAnalog) local spec = self.spec_washable if not spec.washableValue then self:setWashableAddon(true) end end function WashableAddon:setWashableAddon(washableValue, noEventSend) local spec = self.spec_washable SetWashableAddon.sendEvent(self, washableValue, noEventSend) spec.washableValue = washableValue end SetWashableAddon = {} SetWashableAddon_mt = Class(SetWashableAddon, Event) InitEventClass(SetWashableAddon, "SetWashableAddon") function SetWashableAddon:emptyNew() local self = Event:new(SetWashableAddon_mt) return self end function SetWashableAddon:new(object, washableValue) local self = SetWashableAddon:emptyNew() self.object = object self.washableValue = washableValue return self end function SetWashableAddon:readStream(streamId, connection) self.object = NetworkUtil.readNodeObject(streamId) self.washableValue = streamReadBool(streamId) self:run(connection) end function SetWashableAddon:writeStream(streamId, connection) NetworkUtil.writeNodeObject(streamId, self.object) streamWriteBool(streamId, self.washableValue) end function SetWashableAddon:run(connection) if not connection:getIsServer() then g_server:broadcastEvent(self, false, connection, self.object) end if self.object ~= nil then self.object:setWashableAddon(self.washableValue, true) end end function SetWashableAddon.sendEvent(vehicle, washableValue, noEventSend) if washableValue ~= vehicle.spec_washable.washableValue then if noEventSend == nil or noEventSend == false then if g_server ~= nil then g_server:broadcastEvent(SetWashableAddon:new(vehicle, washableValue), nil, nil, vehicle) else g_client:getServerConnection():sendEvent(SetWashableAddon:new(vehicle, washableValue)) end end end end